
class Game {
    width = 0
    height = 0
    htmlParent = null
    gameObjects = []


    constructor(width, height, htmlParent) {
        this.width = width
        this.height = height
        this.htmlParent = htmlParent

        for (let y = 0; y < this.height; y++) {
            let row = document.createElement('tr')
            for (let x = 0; x < this.height; x++) {
                let cell = document.createElement('td')
                cell.id = `cell-${x}-${y}`
                cell.class = 'cell'
                row.appendChild(cell)
            }
            this.htmlParent.appendChild(row)
        }

        // todo: setInterval na gameTick
    }

    /*
     Funkce kterou podstrcime hadovi, aby se mohl vykreslit
     */
    drawElement(x, y, color) {
        const cell = document.getElementById(`cell-${x}-${y}`)
        cell.style.background = color
    }

    addGameObject(gameObject){
        if(this.gameObjects.includes(gameObject)){
            throw new Error('object already added')
        }
        this.gameObjects.push(gameObject)
    }

    step() {
        // Zavolej vsem objektum gameTick
        for(const object of this.gameObjects){
            object.step()
        }
        // tady se vsichni co chteli pohli

        // Tady se vyhodnoti kolize
        for(const object1 of this.gameObjects){
            for(const object2 of this.gameObjects) {
                if(object1 === object2) { break }
                const stringParts1 = object1.getParts().map(souradnice=>souradnice.join("_"))
                const stringParts2 = object2.getParts().map(souradnice=>souradnice.join("_"))
 
                const intersection = stringParts1.filter(value => stringParts2.includes(value));
                if(intersection.length > 0){
                    // dochazi ke kolizi dvou objektu
                    this.solveCollision(object1, object2)
                }
            }
        }
    }
    // (a+b)*(b+a)
    solveCollision(object1, object2){
        if((object1.constructor.name === 'Apple' && 
        object2.constructor.name === 'Snake') ||
        (object1.constructor.name === 'Snake' && 
        object2.constructor.name === 'Apple')){

            let apple, snake
            if(object1.constructor.name === 'Apple'){
                apple = object1
                snake = object2
            } else {
                apple = object2
                snake = object1
            }
               // odstran jablko
               const appleIndex = this.gameObjects.indexOf(apple)
               this.gameObjects.splice(appleIndex,1)
               // had se zvetsi
               snake.hasEaten = true
               // vyrob nove jablko
               this.createRandomApple()

        }

    }

    createRandomApple(){
        let apple = new Apple(
            Math.floor(Math.random() * this.width),
            Math.floor(Math.random() * this.height)
        )
        this.addGameObject(apple)
    }

    render() {
        // Smaz vsechno
        for (let y = 0; y < this.height; y++) {
            for (let x = 0; x < this.height; x++) {
                this.drawElement(x, y, 'white')
            }
        }
        // Vykresli vsechny objekty znovu
        for (const object of this.gameObjects) {
            object.draw(this.drawElement)
        }
    }

    stepAndRender(){
        this.step()
        this.render()
    }
}
